The Permify Watch API acts as a real-time broadcaster that shows changes in the relation tuples.The Watch API exclusively supports gRPC and works with PostgreSQL, given the track_commit_timestamp option is enabled. Please note, it doesn’t support in-memory databases or HTTP communication.
To ensure data consistency and synchronization between your application and Permify, enable track_commit_timestamp on
your PostgreSQL server. This can be done by executing the following options in your PostgreSQL:
Red Hat-based systems: /var/lib/pgsql/data/postgresql.conf
Add or modify the following line in the postgresql.conf file:
track_commit_timestamp = on
Save and close the postgresql.conf file.
Reload the PostgreSQL configuration for the changes to take effect. This can be done via the PostgreSQL console:
SELECT pg_reload_conf();
Or if you have command line access, use:
sudo service postgresql reload
Please ensure you have the necessary permissions to execute these commands or modify the postgresql.conf file. Also, remember that changes in the postgresql.conf file will persist across restarts, while the SQL method may need to be reapplied depending on your PostgreSQL version and setup.
Important Configuration Requirement: To use the Watch API, it must be enabled in your configuration file. Add or modify the following lines:
service: watch: enabled: true
For performance guidance, scaling strategies, and reconnection best practices, see Watch — Operations.
Identifier of the tenant, if you are not using multi-tenancy (have only one tenant) use pre-inserted tenant t1 for this field. Required, and must match the pattern \“[a-zA-Z0-9-,]+\“, max 64 bytes.
Body
application/json
WatchRequest is the request message for the Watch RPC. It contains the
details needed to establish a watch stream.
{"docsConfig":{"theme":"mint","$schema":"https://mintlify.com/docs.json","name":"FGA Documentation","colors":{"primary":"#F58320","light":"#fb923c","dark":"#ea580c"},"logo":{"light":"https://mintcdn.com/permify/s--v0P7cOOW3QatA/logo/light.svg?fit=max\u0026auto=format\u0026n=s--v0P7cOOW3QatA\u0026q=85\u0026s=35df6af816b704ec52d1461bb85c5057","dark":"https://mintcdn.com/permify/s--v0P7cOOW3QatA/logo/dark.svg?fit=max\u0026auto=format\u0026n=s--v0P7cOOW3QatA\u0026q=85\u0026s=3cba8f1833c1058096bf4924e49f8931","href":"/"},"favicon":"https://mintcdn.com/permify/s--v0P7cOOW3QatA/favicon.png?fit=max\u0026auto=format\u0026n=s--v0P7cOOW3QatA\u0026q=85\u0026s=f88a89d54d5d30758364ce67ba61ef7f","appearance":{"default":"light","strict":false},"background":{"color":{"light":"#ffffff","dark":"#0f172a"}},"navbar":{"links":[{"href":"/docs/","label":"FusionAuth Documentation"}]},"footer":{"socials":{"twitter":"https://twitter.com/getPermify","github":"https://github.com/Permify/permify","linkedin":"https://www.linkedin.com/company/permifyco"}},"fonts":{"heading":{"family":"Inter","weight":600},"body":{"family":"Inter","weight":400}},"integrations":{"ga4":{"measurementId":"G-BSRXWHBYR1"}},"styling":{"latex":false},"navigation":{"pages":[]}},"deployment":{"deploymentMetadataValue":{"subdomain":"permify","hasAudioNarration":false,"actualSubdomain":"permify","customDomains":["proxy-docs.permify.co"],"gitSource":{"type":"github","owner":"permify","repo":"permify","deployBranch":"master","contentDirectory":"docs","isPrivate":false,"mountPath":"","label":""},"entitlements":{},"buildId":"6aec9854981b8170d4f27079","clientVersion":"0.0.4088","searchFilterCounts":[{"language":"default","tag":"FGA Documentation","count":57},{"language":"default","tag":"API References","count":24},{"language":"default","tag":"Getting Started","count":12},{"language":"default","tag":"Setting Up","count":12},{"language":"default","tag":"Deployment","count":11},{"language":"default","tag":"Modeling Guides","count":10},{"language":"default","tag":"Permission Service","count":7},{"language":"default","tag":"Real World Examples","count":7},{"language":"default","tag":"Operations","count":6},{"language":"default","tag":"Use Cases","count":6}]},"assistantConfig":{},"basePath":"","hasChatPermissions":false,"hasWebMcpPermissions":false,"toggles":[{"name":"kill-isr","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-mintlify-slack","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-integrations-settings","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"rbac-expansion","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-pr-grouping","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-prefix","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"analytics-v7","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"user-flows-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"no-publish-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-onboarding","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"llms-txt-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving-live","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"stripTemperatureMiddleware","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"support-platform-pylon-zendesk","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"instant-rollback","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications-server","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-fable","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fixed-ai-action-pricing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automation-resolve-merge-conflict","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"scoped-publishing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"mintql","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"page-level-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-version-history-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-page-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"full-page-search","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workspace-projects","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"assistant-v5","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fork-pr-previews","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"revalidation-jwt","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-sso-scim","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"hobby-abuse-scan","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"dashboard-inbox","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-signup","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"turbopuffer-dual-write","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-enabled","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"approve-review-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-metadata","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"sso-setup-deadline-banner","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"turbopuffer-serve","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"live-agents","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"comment-mode","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false}],"googleFontsInlined":false},"customCss":[{"filePath":"custom.css","content":"/* cyrillic-ext */\n@font-face {\n font-family: 'Inter';\n font-style: normal;\n font-weight: 100 900;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/inter/v20/UcC73FwrK3iLTeHuS_nVMrMxCp50SjIa2JL7SUc.woff2) format('woff2');\n unicode-range: U+0460-052F, U+1C80-1C8A, U+20B4, U+2DE0-2DFF, U+A640-A69F, U+FE2E-FE2F;\n}\n/* cyrillic */\n@font-face {\n font-family: 'Inter';\n font-style: normal;\n font-weight: 100 900;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/inter/v20/UcC73FwrK3iLTeHuS_nVMrMxCp50SjIa0ZL7SUc.woff2) format('woff2');\n unicode-range: U+0301, U+0400-045F, U+0490-0491, U+04B0-04B1, U+2116;\n}\n/* greek-ext */\n@font-face {\n font-family: 'Inter';\n font-style: normal;\n font-weight: 100 900;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/inter/v20/UcC73FwrK3iLTeHuS_nVMrMxCp50SjIa2ZL7SUc.woff2) format('woff2');\n unicode-range: U+1F00-1FFF;\n}\n/* greek */\n@font-face {\n font-family: 'Inter';\n font-style: normal;\n font-weight: 100 900;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/inter/v20/UcC73FwrK3iLTeHuS_nVMrMxCp50SjIa1pL7SUc.woff2) format('woff2');\n unicode-range: U+0370-0377, U+037A-037F, U+0384-038A, U+038C, U+038E-03A1, U+03A3-03FF;\n}\n/* vietnamese */\n@font-face {\n font-family: 'Inter';\n font-style: normal;\n font-weight: 100 900;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/inter/v20/UcC73FwrK3iLTeHuS_nVMrMxCp50SjIa2pL7SUc.woff2) format('woff2');\n unicode-range: U+0102-0103, U+0110-0111, U+0128-0129, U+0168-0169, U+01A0-01A1, U+01AF-01B0, U+0300-0301, U+0303-0304, U+0308-0309, U+0323, U+0329, U+1EA0-1EF9, U+20AB;\n}\n/* latin-ext */\n@font-face {\n font-family: 'Inter';\n font-style: normal;\n font-weight: 100 900;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/inter/v20/UcC73FwrK3iLTeHuS_nVMrMxCp50SjIa25L7SUc.woff2) format('woff2');\n unicode-range: U+0100-02BA, U+02BD-02C5, U+02C7-02CC, U+02CE-02D7, U+02DD-02FF, U+0304, U+0308, U+0329, U+1D00-1DBF, U+1E00-1E9F, U+1EF2-1EFF, U+2020, U+20A0-20AB, U+20AD-20C4, U+2113, U+2C60-2C7F, U+A720-A7FF;\n}\n/* latin */\n@font-face {\n font-family: 'Inter';\n font-style: normal;\n font-weight: 100 900;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/inter/v20/UcC73FwrK3iLTeHuS_nVMrMxCp50SjIa1ZL7.woff2) format('woff2');\n unicode-range: U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+0304, U+0308, U+0329, U+2000-206F, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD;\n}\n*,*::before,*::after{font-family:'Inter', -apple-system, BlinkMacSystemFont, 'Segoe UI', system-ui, sans-serif!important}pre,code,kbd,samp,tt{font-family:'JetBrains Mono', 'Fira Code', 'Menlo', 'Monaco', 'Consolas', monospace!important}html:not(.dark) span#background-color{background:transparent!important}html:not(.dark){background-color:#ffffff!important;background-image:radial-gradient(768px at right top, rgba(199, 210, 254, 0.65) 0%, rgba(255, 255, 255, 1.0) 80%),\n linear-gradient(rgba(99, 102, 241, 0.4) 1px, transparent 1px),\n linear-gradient(90deg, rgba(99, 102, 241, 0.4) 1px, transparent 1px)!important;background-size:100% 30000px, 34px 34px, 34px 34px!important;background-position:0 0, 0 0, 0 0!important;background-repeat:no-repeat, repeat, repeat!important;background-attachment:local, local, local!important}:root{--fa-orange: #F58320;--fa-orange-light: #fb923c;--fa-orange-dark: #ea580c;--fa-slate-800: #1e293b;--fa-slate-700: #334155;--fa-slate-100: #F1F5F9;--fa-slate-200: #E2E8F0}#banner{background-color:var(--fa-slate-800)!important;color:#fff!important;border-bottom:2px solid var(--fa-orange)!important}#banner a{color:var(--fa-orange-light)!important;text-decoration:underline!important}#banner a:hover{color:#fff!important}#navbar{background-color:#0f172a!important;border-bottom:1px solid #334155!important}#navbar #navbar-transition{background-color:transparent!important}#navbar a{color:#e2e8f0!important}#navbar a:hover{color:var(--fa-orange-light)!important}#navbar li.navbar-link a{color:#ffffff!important;font-size:0.875rem!important;font-weight:600!important;letter-spacing:-0.01em!important;opacity:1!important}#navbar li.navbar-link a:hover{color:var(--fa-orange-light)!important}#navbar button{color:#94a3b8!important}#navbar button:hover{color:#e2e8f0!important}#navbar a[data-slot=\"context-menu-trigger\"]{display:inline-flex!important;align-items:center!important}#navbar a[data-slot=\"context-menu-trigger\"] img{height:3rem!important;width:auto!important;order:1}#navbar a[data-slot=\"context-menu-trigger\"]::before{content:\"/\";color:#64748b;font-size:1.5rem;font-weight:300;margin-left:0.75rem;margin-right:0.375rem;line-height:1;order:2}#navbar a[data-slot=\"context-menu-trigger\"]::after{content:\"FGA Docs\";color:#ffffff;font-size:1.5rem;font-weight:700;letter-spacing:-0.025em;line-height:1;order:3}[data-testid=\"sidebar\"] a[aria-current=\"page\"],aside a[aria-current=\"page\"]{border-left:3px solid var(--fa-orange)!important;color:var(--fa-orange-dark)!important;font-weight:600!important;background-color:rgba(245, 131, 32, 0.06)!important}[data-testid=\"sidebar\"] h3,aside h3{color:var(--fa-slate-800)!important;text-transform:uppercase!important;font-size:0.7rem!important;letter-spacing:0.06em!important;font-weight:700!important}:is(.dark) [data-testid=\"sidebar\"] h3,:is(.dark) aside h3{color:var(--fa-slate-200)!important}[data-testid=\"sidebar\"] a,aside a{color:var(--fa-slate-700)!important;transition:color 0.15s ease!important}[data-testid=\"sidebar\"] a:hover,aside a:hover{color:var(--fa-orange)!important}:is(.dark) [data-testid=\"sidebar\"] a,:is(.dark) aside a{color:#cbd5e1!important}:is(.dark) [data-testid=\"sidebar\"] a:hover,:is(.dark) aside a:hover{color:var(--fa-orange-light)!important}a[class*=\"Button\"],button[class*=\"primary\"],.cta-button,[data-testid=\"cta-button\"]{background-color:var(--fa-orange)!important;border-color:var(--fa-orange)!important;color:#fff!important;border-radius:6px!important;transition:background-color 0.15s ease!important}a[class*=\"Button\"]:hover,button[class*=\"primary\"]:hover,.cta-button:hover,[data-testid=\"cta-button\"]:hover{background-color:var(--fa-orange-dark)!important;border-color:var(--fa-orange-dark)!important}article a,.prose a,main a:not([class]){color:var(--fa-orange-dark)!important;text-decoration-color:rgba(245, 131, 32, 0.3)!important}article a:hover,.prose a:hover,main a:not([class]):hover{color:var(--fa-orange)!important;text-decoration-color:var(--fa-orange)!important}:is(.dark) article a,:is(.dark) .prose a,:is(.dark) main a:not([class]){color:var(--fa-orange-light)!important}[class*=\"anchor-card\"],[class*=\"AnchorCard\"]{border:1px solid var(--fa-slate-200)!important;border-radius:8px!important;transition:border-color 0.15s ease, box-shadow 0.15s ease!important}[class*=\"anchor-card\"]:hover,[class*=\"AnchorCard\"]:hover{border-color:var(--fa-orange)!important;box-shadow:0 2px 8px rgba(245, 131, 32, 0.12)!important}article h1,article h2,article h3,.prose h1,.prose h2,.prose h3{color:var(--fa-slate-800)!important}:is(.dark) article h1,:is(.dark) article h2,:is(.dark) article h3,:is(.dark) .prose h1,:is(.dark) .prose h2,:is(.dark) .prose h3{color:#f1f5f9!important}pre,code{border-radius:6px!important}pre{background-color:#1f273b!important}:is(.dark) pre{background-color:#00081a!important}:not(pre)>code{background-color:#f1f5f9!important;color:var(--fa-slate-800)!important;padding:0.15em 0.4em!important;border-radius:4px!important;font-size:0.875em!important}:is(.dark) :not(pre)>code{background-color:#1e293b!important;color:#e2e8f0!important}table th{background-color:var(--fa-slate-800)!important;color:#fff!important;font-weight:600!important}:is(.dark) table th{background-color:#0f172a!important}table tr:nth-child(even){background-color:rgba(241, 245, 249, 0.5)!important}:is(.dark) table tr:nth-child(even){background-color:rgba(30, 41, 59, 0.3)!important}[role=\"tab\"][aria-selected=\"true\"]{color:var(--fa-orange)!important;border-bottom-color:var(--fa-orange)!important}::-webkit-scrollbar{width:6px;height:6px}::-webkit-scrollbar-thumb{background:#94a3b8;border-radius:3px}::-webkit-scrollbar-track{background:transparent}::selection{background-color:rgba(245, 131, 32, 0.2);color:inherit}[class*=\"feedback\"] button:hover,[class*=\"Feedback\"] button:hover{color:var(--fa-orange)!important}[class*=\"badge\"],[class*=\"Badge\"]{border-radius:4px!important}mark,[class*=\"highlight\"]{background-color:rgba(245, 131, 32, 0.15)!important}[class*=\"Card\"],[class*=\"card\"]{border-radius:8px!important}"}],"page":{"pagePath":"api-reference/watch/watch-changes","slug":"/api-reference/watch/watch-changes","pageMetadata":{"title":"Watch API","openapi":"post /v1/tenants/{tenant_id}/watch","description":null,"href":"/api-reference/watch/watch-changes"},"pageType":"default","mdx":{"mdxSource":{"compiledSource":"\"use strict\";const{Fragment:_Fragment,jsx:_jsx,jsxs:_jsxs}=arguments[0];const{useMDXComponents:_provideComponents}=arguments[0];function _createMdxContent(props){const _components={a:`a`,code:`code`,li:`li`,ol:`ol`,p:`p`,pre:`pre`,span:`span`,ul:`ul`,..._provideComponents(),...props.components},{CodeBlock,Heading,Info}=_components;if(!CodeBlock)_missingMdxReference(`CodeBlock`,true);if(!Heading)_missingMdxReference(`Heading`,true);if(!Info)_missingMdxReference(`Info`,true);return _jsxs(_Fragment,{children:[_jsx(_components.p,{children:`The Permify Watch API acts as a real-time broadcaster that shows changes in the relation tuples.`}),`\n`,_jsx(_components.p,{children:`The Watch API exclusively supports gRPC and works with PostgreSQL, given the track_commit_timestamp option is enabled. Please note, it doesn’t support in-memory databases or HTTP communication.`}),`\n`,_jsx(Heading,{level:`2`,id:`requirements`,children:`Requirements`}),`\n`,_jsxs(_components.ul,{children:[`\n`,_jsx(_components.li,{children:`PostgreSQL database set up with track_commit_timestamp option enabled`}),`\n`]}),`\n`,_jsx(Heading,{level:`2`,id:`enabling-track_commit_timestamp-on-postgresql`,children:`Enabling track_commit_timestamp on PostgreSQL`}),`\n`,_jsx(_components.p,{children:`To ensure data consistency and synchronization between your application and Permify, enable track_commit_timestamp on\nyour PostgreSQL server. This can be done by executing the following options in your PostgreSQL:`}),`\n`,_jsx(Heading,{level:`3`,id:`option-1-sql-command`,children:`Option 1: SQL Command`}),`\n`,_jsxs(_components.ol,{children:[`\n`,_jsxs(_components.li,{children:[`\n`,_jsx(_components.p,{children:`Open your PostgreSQL command line interface.`}),`\n`]}),`\n`,_jsxs(_components.li,{children:[`\n`,_jsx(_components.p,{children:`Execute the following command:`}),`\n`,_jsx(CodeBlock,{filename:``,numberOfLines:`1`,language:`sql`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`sql`,children:_jsxs(_components.code,{language:`sql`,numberOfLines:`1`,children:[_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#569CD6`},children:`ALTER`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#569CD6`},children:` SYSTEM`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#569CD6`},children:` SET`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` track_commit_timestamp `}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#D4D4D4`},children:`=`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#569CD6`},children:` ON`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`;`})]}),`\n`]})})}),`\n`]}),`\n`,_jsxs(_components.li,{children:[`\n`,_jsx(_components.p,{children:`Reload the configuration with the following command:`}),`\n`,_jsx(CodeBlock,{filename:``,numberOfLines:`1`,language:`sql`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`sql`,children:_jsxs(_components.code,{language:`sql`,numberOfLines:`1`,children:[_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#569CD6`},children:`SELECT`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` pg_reload_conf();`})]}),`\n`]})})}),`\n`]}),`\n`]}),`\n`,_jsx(Heading,{level:`3`,id:`option-2-editing-postgresql-conf`,children:`Option 2: Editing postgresql.conf`}),`\n`,_jsxs(_components.ol,{children:[`\n`,_jsxs(_components.li,{children:[`\n`,_jsx(_components.p,{children:`Find and open the postgresql.conf file in a text editor. Its location depends on your PostgreSQL installation. Common\nlocations are:`}),`\n`,_jsxs(_components.ul,{children:[`\n`,_jsx(_components.li,{children:`Debian-based systems: /etc/postgresql/[version]/main/postgresql.conf`}),`\n`,_jsx(_components.li,{children:`Red Hat-based systems: /var/lib/pgsql/data/postgresql.conf`}),`\n`]}),`\n`]}),`\n`,_jsxs(_components.li,{children:[`\n`,_jsx(_components.p,{children:`Add or modify the following line in the postgresql.conf file:`}),`\n`,_jsx(CodeBlock,{numberOfLines:`2`,language:`text`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`text`,children:_jsxs(_components.code,{language:`text`,numberOfLines:`2`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`track_commit_timestamp = on`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{})})]})})}),`\n`]}),`\n`,_jsxs(_components.li,{children:[`\n`,_jsx(_components.p,{children:`Save and close the postgresql.conf file.`}),`\n`]}),`\n`,_jsxs(_components.li,{children:[`\n`,_jsx(_components.p,{children:`Reload the PostgreSQL configuration for the changes to take effect. This can be done via the PostgreSQL console:`}),`\n`,_jsx(CodeBlock,{filename:``,numberOfLines:`1`,language:`sql`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`sql`,children:_jsxs(_components.code,{language:`sql`,numberOfLines:`1`,children:[_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#569CD6`},children:`SELECT`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` pg_reload_conf();`})]}),`\n`]})})}),`\n`,_jsx(_components.p,{children:`Or if you have command line access, use:`}),`\n`,_jsx(CodeBlock,{filename:``,numberOfLines:`1`,language:`shellscript`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`shellscript`,children:_jsxs(_components.code,{language:`shellscript`,numberOfLines:`1`,children:[_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#953800`,\"--shiki-dark\":`#DCDCAA`},children:`sudo`}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` service`}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` postgresql`}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` reload`})]}),`\n`]})})}),`\n`]}),`\n`]}),`\n`,_jsx(_components.p,{children:`Please ensure you have the necessary permissions to execute these commands or modify the postgresql.conf file. Also, remember that changes in the postgresql.conf file will persist across restarts, while the SQL method may need to be reapplied depending on your PostgreSQL version and setup.`}),`\n`,_jsxs(Info,{children:[_jsx(_components.p,{children:`Important Configuration Requirement: To use the Watch API, it must be enabled in your configuration file. Add or modify the following lines:`}),_jsx(CodeBlock,{filename:``,numberOfLines:`3`,language:`yaml`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`yaml`,children:_jsxs(_components.code,{language:`yaml`,numberOfLines:`3`,children:[_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#569CD6`},children:`service`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`:`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#569CD6`},children:` watch`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`:`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#569CD6`},children:` enabled`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#569CD6`},children:`true`})]}),`\n`]})})})]}),`\n`,_jsxs(_components.p,{children:[`For performance guidance, scaling strategies, and reconnection best practices, see `,_jsx(_components.a,{href:`/operations/watch`,children:`Watch — Operations`}),`.`]})]})}function MDXContent(props={}){const{wrapper:MDXLayout}={..._provideComponents(),...props.components};return MDXLayout?_jsx(MDXLayout,{...props,children:_jsx(_createMdxContent,{...props})}):_createMdxContent(props)}return{default:MDXContent};function _missingMdxReference(id,component){throw new Error(`Expected `+(component?`component`:`object`)+\" `\"+id+\"` to be defined: you likely forgot to import, pass, or provide it.\")}","frontmatter":{},"scope":{"config":{},"pageMetadata":{"title":"Watch API","openapi":"post /v1/tenants/{tenant_id}/watch","description":null,"href":"/api-reference/watch/watch-changes"}}},"mdxSourceWithNoJs":null},"mdxExtracts":{"tableOfContents":[{"title":"Requirements","slug":"requirements","depth":2,"children":[]},{"title":"Enabling track_commit_timestamp on PostgreSQL","slug":"enabling-track_commit_timestamp-on-postgresql","depth":2,"children":[{"title":"Option 1: SQL Command","slug":"option-1-sql-command","depth":3,"children":[]},{"title":"Option 2: Editing postgresql.conf","slug":"option-2-editing-postgresql-conf","depth":3,"children":[]}]}],"codeExamples":{}},"jsLinks":["/_mintlify/custom/permify/03abf5c771cc7674/gurubase.js"],"openApiReferenceData":{"operation":{"summary":"watch changes","operationId":"watch.watch","responses":{"200":"32215269-af1b-4c35-b019-b33b0ed09269","default":"6b1c63ea-470a-4435-8428-dc63159469e3"},"parameters":["d1c507da-c929-4068-938d-6426e3a2b256"],"requestBody":"d7b9440d-4651-4664-8490-65c246b66f3b","tags":["Watch"],"x-codeSamples":[{"label":"go","lang":"go","source":"cr, err := client.Watch.Watch(context.Background(), \u0026v1.WatchRequest{\n TenantId: \"t1\",\n SnapToken: \"\",\n})\n// handle stream response\nfor {\n res, err := cr.Recv()\n\n if err == io.EOF {\n break\n }\n\n // res.Changes\n}\n"},{"label":"node","lang":"javascript","source":"const permify = require(\"@permify/permify-node\");\nconst {WatchResponse} = require(\"@permify/permify-node/dist/src/grpc/generated/base/v1/service\");\n\nfunction main() {\n const client = new permify.grpc.newClient({\n endpoint: \"localhost:3478\",\n });\n\n let res = client.watch.watch({\n tenantId: \"t1\",\n snapToken: \"\"\n });\n\n handle(res);\n}\n\nasync function handle(res: AsyncIterable\u003cWatchResponse>) {\n for await (const response of res) {\n // response.changes\n }\n}\n"}],"method":"post","type":"path","servers":[],"security":[],"path":"/v1/tenants/{tenant_id}/watch","baseUrlOptions":[],"title":"watch changes","description":"","codeSamples":[{"label":"go","lang":"go","source":"cr, err := client.Watch.Watch(context.Background(), \u0026v1.WatchRequest{\n TenantId: \"t1\",\n SnapToken: \"\",\n})\n// handle stream response\nfor {\n res, err := cr.Recv()\n\n if err == io.EOF {\n break\n }\n\n // res.Changes\n}\n"},{"label":"node","lang":"javascript","source":"const permify = require(\"@permify/permify-node\");\nconst {WatchResponse} = require(\"@permify/permify-node/dist/src/grpc/generated/base/v1/service\");\n\nfunction main() {\n const client = new permify.grpc.newClient({\n endpoint: \"localhost:3478\",\n });\n\n let res = client.watch.watch({\n tenantId: \"t1\",\n snapToken: \"\"\n });\n\n handle(res);\n}\n\nasync function handle(res: AsyncIterable\u003cWatchResponse>) {\n for await (const response of res) {\n // response.changes\n }\n}\n"}],"requiredOnlyExamples":false,"requestExampleType":"codeSamples","responseExampleType":"generated"},"dependencies":{"parameters":{"d1c507da-c929-4068-938d-6426e3a2b256":{"name":"tenant_id","description":"Identifier of the tenant, if you are not using multi-tenancy (have only one tenant) use pre-inserted tenant \u003ccode>t1\u003c/code> for this field. Required, and must match the pattern \\“[a-zA-Z0-9-,]+\\“, max 64 bytes.","in":"path","required":true,"schema":{"type":"string","isRequired":true,"description":"Identifier of the tenant, if you are not using multi-tenancy (have only one tenant) use pre-inserted tenant \u003ccode>t1\u003c/code> for this field. Required, and must match the pattern \\“[a-zA-Z0-9-,]+\\“, max 64 bytes.","uniqueKey":"","typeLabel":"string"}}},"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"snap_token":{"type":"string","description":"The snap token to avoid stale cache, see more details on [Snap Tokens](../../operations/snap-tokens).","uniqueKey":"snap_token","typeLabel":"string"}},"description":"WatchRequest is the request message for the Watch RPC. It contains the\ndetails needed to establish a watch stream.","uniqueKey":"","typeLabel":"object"},"examples":{"Example":{"title":"Example","value":{"snap_token":"\u003cstring>"}}},"exampleType":"generated"}},"required":true,"exampleType":"generated"},"responses":{"32215269-af1b-4c35-b019-b33b0ed09269":{"description":"A successful response.(streaming responses)","content":{"application/json":{"schema":{"type":"object","properties":{"result":{"type":"object","properties":{"changes":{"type":"object","properties":{"snap_token":{"type":"string","description":"The snapshot token.","uniqueKey":"result.changes.snap_token","typeLabel":"string"},"data_changes":{"type":"array","items":{"type":"object","properties":{"operation":{"type":"string","enum":["OPERATION_UNSPECIFIED","OPERATION_CREATE","OPERATION_DELETE"],"default":"OPERATION_UNSPECIFIED","description":" - OPERATION_UNSPECIFIED: Default operation, not specified.\n - OPERATION_CREATE: Creation operation.\n - OPERATION_DELETE: Deletion operation.","uniqueKey":"result.changes.data_changes.items.[INDEX].operation","typeLabel":"enum\u003cstring>"},"tuple":{"type":"object","properties":{"entity":{"type":"object","properties":{"type":{"type":"string","uniqueKey":"result.changes.data_changes.items.[INDEX].tuple.entity.type","typeLabel":"string"},"id":{"type":"string","uniqueKey":"result.changes.data_changes.items.[INDEX].tuple.entity.id","typeLabel":"string"}},"description":"Entity represents an entity with a type and an identifier.","uniqueKey":"result.changes.data_changes.items.[INDEX].tuple.entity","typeLabel":"object"},"relation":{"type":"string","uniqueKey":"result.changes.data_changes.items.[INDEX].tuple.relation","typeLabel":"string"},"subject":{"type":"object","properties":{"type":{"type":"string","uniqueKey":"result.changes.data_changes.items.[INDEX].tuple.subject.type","typeLabel":"string"},"id":{"type":"string","uniqueKey":"result.changes.data_changes.items.[INDEX].tuple.subject.id","typeLabel":"string"},"relation":{"type":"string","uniqueKey":"result.changes.data_changes.items.[INDEX].tuple.subject.relation","typeLabel":"string"}},"description":"Subject represents an entity subject with a type, an identifier, and a relation.","uniqueKey":"result.changes.data_changes.items.[INDEX].tuple.subject","typeLabel":"object"}},"description":"Tuple is a structure that includes an entity, a relation, and a subject.","uniqueKey":"result.changes.data_changes.items.[INDEX].tuple","typeLabel":"object"},"attribute":{"type":"object","properties":{"entity":{"type":"object","properties":{"type":{"type":"string","uniqueKey":"result.changes.data_changes.items.[INDEX].attribute.entity.type","typeLabel":"string"},"id":{"type":"string","uniqueKey":"result.changes.data_changes.items.[INDEX].attribute.entity.id","typeLabel":"string"}},"description":"Entity represents an entity with a type and an identifier.","uniqueKey":"result.changes.data_changes.items.[INDEX].attribute.entity","typeLabel":"object"},"attribute":{"type":"string","title":"Name of the attribute","uniqueKey":"result.changes.data_changes.items.[INDEX].attribute.attribute","typeLabel":"string"},"value":{"type":"object","properties":{"@type":{"type":"string","description":"Identifies the type of the serialized Protobuf message with a URI reference\nconsisting of a prefix ending in a slash and the fully-qualified type name.\n\nExample: type.googleapis.com/google.protobuf.StringValue\n\nThis string must contain at least one `/` character, and the content after\nthe last `/` must be the fully-qualified name of the type in canonical\nform, without a leading dot. Do not write a scheme on these URI references\nso that clients do not attempt to contact them.\n\nThe prefix is arbitrary and Protobuf implementations are expected to\nsimply strip off everything up to and including the last `/` to identify\nthe type. `type.googleapis.com/` is a common default prefix that some\nlegacy implementations require. This prefix does not indicate the origin of\nthe type, and URIs containing it are not expected to respond to any\nrequests.\n\nAll type URL strings must be legal URI references with the additional\nrestriction (for the text format) that the content of the reference\nmust consist only of alphanumeric characters, percent-encoded escapes, and\ncharacters in the following set (not including the outer backticks):\n`/-.~_!$\u0026()*+,;=`. Despite our allowing percent encodings, implementations\nshould not unescape them to prevent confusion with existing parsers. For\nexample, `type.googleapis.com%2FFoo` should be rejected.\n\nIn the original design of `Any`, the possibility of launching a type\nresolution service at these type URLs was considered but Protobuf never\nimplemented one and considers contacting these URLs to be problematic and\na potential security issue. Do not attempt to contact type URLs.","uniqueKey":"result.changes.data_changes.items.[INDEX].attribute.value.@type","typeLabel":"string"}},"additionalProperties":{"oneOf":[{}],"uniqueKey":"result.changes.data_changes.items.[INDEX].attribute.value.additionalProperties","typeLabel":"any"},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nIn its binary encoding, an `Any` is an ordinary message; but in other wire\nforms like JSON, it has a special encoding. The format of the type URL is\ndescribed on the `type_url` field.\n\nProtobuf APIs provide utilities to interact with `Any` values:\n\n- A 'pack' operation accepts a message and constructs a generic `Any` wrapper\n around it.\n- An 'unpack' operation reads the content of an `Any` message, either into an\n existing message or a new one. Unpack operations must check the type of the\n value they unpack against the declared `type_url`.\n- An 'is' operation decides whether an `Any` contains a message of the given\n type, i.e. whether it can 'unpack' that type.\n\nThe JSON format representation of an `Any` follows one of these cases:\n\n- For types without special-cased JSON encodings, the JSON format\n representation of the `Any` is the same as that of the message, with an\n additional `@type` field which contains the type URL.\n- For types with special-cased JSON encodings (typically called 'well-known'\n types, listed in https://protobuf.dev/programming-guides/json/#any), the\n JSON format representation has a key `@type` which contains the type URL\n and a key `value` which contains the JSON-serialized value.\n\nThe text format representation of an `Any` is like a message with one field\nwhose name is the type URL in brackets. For example, an `Any` containing a\n`foo.Bar` message may be written `[type.googleapis.com/foo.Bar] { a: 2 }`.","uniqueKey":"result.changes.data_changes.items.[INDEX].attribute.value","typeLabel":"object"}},"description":"Attribute represents an attribute of an entity with a specific type and value.","uniqueKey":"result.changes.data_changes.items.[INDEX].attribute","typeLabel":"object"}},"description":"DataChange represents a single change in data, with an operation type and the actual change which could be a tuple or an attribute.","uniqueKey":"result.changes.data_changes.items.[INDEX]","typeLabel":"object"},"description":"The list of data changes.","uniqueKey":"result.changes.data_changes","typeLabel":"object[]"}},"description":"DataChanges represent changes in data with a snap token and a list of data change objects.","uniqueKey":"result.changes","typeLabel":"object"}},"description":"WatchResponse is the response message for the Watch RPC. It contains the\nchanges in the data that are being watched.","uniqueKey":"result","typeLabel":"object"},"error":{"type":"object","properties":{"code":{"type":"integer","format":"int32","uniqueKey":"error.code","typeLabel":"integer\u003cint32>"},"message":{"type":"string","uniqueKey":"error.message","typeLabel":"string"},"details":{"type":"array","items":{"type":"object","properties":{"@type":{"type":"string","description":"Identifies the type of the serialized Protobuf message with a URI reference\nconsisting of a prefix ending in a slash and the fully-qualified type name.\n\nExample: type.googleapis.com/google.protobuf.StringValue\n\nThis string must contain at least one `/` character, and the content after\nthe last `/` must be the fully-qualified name of the type in canonical\nform, without a leading dot. Do not write a scheme on these URI references\nso that clients do not attempt to contact them.\n\nThe prefix is arbitrary and Protobuf implementations are expected to\nsimply strip off everything up to and including the last `/` to identify\nthe type. `type.googleapis.com/` is a common default prefix that some\nlegacy implementations require. This prefix does not indicate the origin of\nthe type, and URIs containing it are not expected to respond to any\nrequests.\n\nAll type URL strings must be legal URI references with the additional\nrestriction (for the text format) that the content of the reference\nmust consist only of alphanumeric characters, percent-encoded escapes, and\ncharacters in the following set (not including the outer backticks):\n`/-.~_!$\u0026()*+,;=`. Despite our allowing percent encodings, implementations\nshould not unescape them to prevent confusion with existing parsers. For\nexample, `type.googleapis.com%2FFoo` should be rejected.\n\nIn the original design of `Any`, the possibility of launching a type\nresolution service at these type URLs was considered but Protobuf never\nimplemented one and considers contacting these URLs to be problematic and\na potential security issue. Do not attempt to contact type URLs.","uniqueKey":"error.details.items.[INDEX].@type","typeLabel":"string"}},"additionalProperties":{"oneOf":[{}],"uniqueKey":"error.details.items.[INDEX].additionalProperties","typeLabel":"any"},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nIn its binary encoding, an `Any` is an ordinary message; but in other wire\nforms like JSON, it has a special encoding. The format of the type URL is\ndescribed on the `type_url` field.\n\nProtobuf APIs provide utilities to interact with `Any` values:\n\n- A 'pack' operation accepts a message and constructs a generic `Any` wrapper\n around it.\n- An 'unpack' operation reads the content of an `Any` message, either into an\n existing message or a new one. Unpack operations must check the type of the\n value they unpack against the declared `type_url`.\n- An 'is' operation decides whether an `Any` contains a message of the given\n type, i.e. whether it can 'unpack' that type.\n\nThe JSON format representation of an `Any` follows one of these cases:\n\n- For types without special-cased JSON encodings, the JSON format\n representation of the `Any` is the same as that of the message, with an\n additional `@type` field which contains the type URL.\n- For types with special-cased JSON encodings (typically called 'well-known'\n types, listed in https://protobuf.dev/programming-guides/json/#any), the\n JSON format representation has a key `@type` which contains the type URL\n and a key `value` which contains the JSON-serialized value.\n\nThe text format representation of an `Any` is like a message with one field\nwhose name is the type URL in brackets. For example, an `Any` containing a\n`foo.Bar` message may be written `[type.googleapis.com/foo.Bar] { a: 2 }`.","uniqueKey":"error.details.items.[INDEX]","typeLabel":"object"},"uniqueKey":"error.details","typeLabel":"object[]"}},"uniqueKey":"error","typeLabel":"object"}},"title":"Stream result of WatchResponse","uniqueKey":"","typeLabel":"Stream result of WatchResponse · object"},"examples":{"Example":{"title":"Example","value":{"result":{"changes":{"snap_token":"\u003cstring>","data_changes":[{"operation":"OPERATION_UNSPECIFIED","tuple":{"entity":{"type":"\u003cstring>","id":"\u003cstring>"},"relation":"\u003cstring>","subject":{"type":"\u003cstring>","id":"\u003cstring>","relation":"\u003cstring>"}},"attribute":{"entity":{"type":"\u003cstring>","id":"\u003cstring>"},"attribute":"\u003cstring>","value":{"@type":"\u003cstring>"}}}]}},"error":{"code":123,"message":"\u003cstring>","details":[{"@type":"\u003cstring>"}]}}}},"exampleType":"generated"}},"exampleType":"generated"},"6b1c63ea-470a-4435-8428-dc63159469e3":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"type":"object","properties":{"code":{"type":"integer","format":"int32","uniqueKey":"code","typeLabel":"integer\u003cint32>"},"message":{"type":"string","uniqueKey":"message","typeLabel":"string"},"details":{"type":"array","items":{"type":"object","properties":{"@type":{"type":"string","description":"Identifies the type of the serialized Protobuf message with a URI reference\nconsisting of a prefix ending in a slash and the fully-qualified type name.\n\nExample: type.googleapis.com/google.protobuf.StringValue\n\nThis string must contain at least one `/` character, and the content after\nthe last `/` must be the fully-qualified name of the type in canonical\nform, without a leading dot. Do not write a scheme on these URI references\nso that clients do not attempt to contact them.\n\nThe prefix is arbitrary and Protobuf implementations are expected to\nsimply strip off everything up to and including the last `/` to identify\nthe type. `type.googleapis.com/` is a common default prefix that some\nlegacy implementations require. This prefix does not indicate the origin of\nthe type, and URIs containing it are not expected to respond to any\nrequests.\n\nAll type URL strings must be legal URI references with the additional\nrestriction (for the text format) that the content of the reference\nmust consist only of alphanumeric characters, percent-encoded escapes, and\ncharacters in the following set (not including the outer backticks):\n`/-.~_!$\u0026()*+,;=`. Despite our allowing percent encodings, implementations\nshould not unescape them to prevent confusion with existing parsers. For\nexample, `type.googleapis.com%2FFoo` should be rejected.\n\nIn the original design of `Any`, the possibility of launching a type\nresolution service at these type URLs was considered but Protobuf never\nimplemented one and considers contacting these URLs to be problematic and\na potential security issue. Do not attempt to contact type URLs.","uniqueKey":"details.items.[INDEX].@type","typeLabel":"string"}},"additionalProperties":{"oneOf":[{}],"uniqueKey":"details.items.[INDEX].additionalProperties","typeLabel":"any"},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nIn its binary encoding, an `Any` is an ordinary message; but in other wire\nforms like JSON, it has a special encoding. The format of the type URL is\ndescribed on the `type_url` field.\n\nProtobuf APIs provide utilities to interact with `Any` values:\n\n- A 'pack' operation accepts a message and constructs a generic `Any` wrapper\n around it.\n- An 'unpack' operation reads the content of an `Any` message, either into an\n existing message or a new one. Unpack operations must check the type of the\n value they unpack against the declared `type_url`.\n- An 'is' operation decides whether an `Any` contains a message of the given\n type, i.e. whether it can 'unpack' that type.\n\nThe JSON format representation of an `Any` follows one of these cases:\n\n- For types without special-cased JSON encodings, the JSON format\n representation of the `Any` is the same as that of the message, with an\n additional `@type` field which contains the type URL.\n- For types with special-cased JSON encodings (typically called 'well-known'\n types, listed in https://protobuf.dev/programming-guides/json/#any), the\n JSON format representation has a key `@type` which contains the type URL\n and a key `value` which contains the JSON-serialized value.\n\nThe text format representation of an `Any` is like a message with one field\nwhose name is the type URL in brackets. For example, an `Any` containing a\n`foo.Bar` message may be written `[type.googleapis.com/foo.Bar] { a: 2 }`.","uniqueKey":"details.items.[INDEX]","typeLabel":"object"},"uniqueKey":"details","typeLabel":"object[]"}},"uniqueKey":"","typeLabel":"object"},"examples":{"Example":{"title":"Example","value":{"code":123,"message":"\u003cstring>","details":[{"@type":"\u003cstring>"}]}}},"exampleType":"generated"}},"exampleType":"generated"}},"security":{},"servers":{}},"originalFileLocation":"api-reference/openapi.json"},"subdomain":"permify","siteName":"FGA Documentation","title":"Watch API - FGA Documentation","navMaps":{"firstHrefInVersion":{},"firstHrefInLanguage":{}},"lastModified":"2026-11-05T14:53:17.791Z","originalFileLocation":"api-reference/watch/watch-changes.mdx"},"headHtml":"\u003cscript data-mint-head>(function(){var d=document.documentElement,p=null;if(!p){try{p=localStorage.getItem(\"isDarkMode\")}catch(e){}if(p==='true')p='dark';else if(p==='false')p='light';if(p!=='light'\u0026\u0026p!=='dark'\u0026\u0026p!=='system')p=\"light\"}var r=p==='system'?(matchMedia(\"(prefers-color-scheme: dark)\").matches?'dark':'light'):p;d.classList.remove(r==='dark'?'light':'dark');d.classList.add(r);d.setAttribute(\"data-theme-preference\",p)})();\u003c/script>\u003cmeta data-mint-head name=\"application-name\" content=\"FGA Documentation\">\u003cmeta data-mint-head name=\"generator\" content=\"Mintlify\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"192x192\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon/android-chrome-192x192.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"apple-touch-icon\" type=\"image/png\" sizes=\"180x180\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon/apple-touch-icon.png\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"16x16\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon/favicon-16x16.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"32x32\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon/favicon-32x32.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"shortcut icon\" type=\"image/x-icon\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon/favicon.ico\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"192x192\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon-dark/android-chrome-192x192.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"16x16\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon-dark/favicon-16x16.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"32x32\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon-dark/favicon-32x32.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"shortcut icon\" type=\"image/x-icon\" href=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon-dark/favicon.ico\" media=\"(prefers-color-scheme: dark)\">\u003cmeta data-mint-head property=\"og:title\" content=\"Watch API - FGA Documentation\">\u003cmeta data-mint-head property=\"og:site_name\" content=\"FGA Documentation\">\u003cmeta data-mint-head property=\"og:url\" content=\"https://proxy-docs.permify.co/api-reference/watch/watch-changes\">\u003cmeta data-mint-head property=\"og:type\" content=\"website\">\u003cmeta data-mint-head property=\"og:image\" content=\"https://permify.mintlify.site/_mintlify/api/og/v2?division=Watch+Service\u0026amp;title=Watch+API\u0026amp;theme=9be289e78f6ac24dc5c5d06f\u0026amp;signature=7ca6cc3b7a1b8f392f063f307c9310f06a874ef4485dcc0b3bc2bcde2dd57e92\">\u003cmeta data-mint-head property=\"og:image:width\" content=\"1200\">\u003cmeta data-mint-head property=\"og:image:height\" content=\"630\">\u003cmeta data-mint-head name=\"twitter:card\" content=\"summary_large_image\">\u003cmeta data-mint-head name=\"twitter:title\" content=\"Watch API - FGA Documentation\">\u003cmeta data-mint-head name=\"twitter:image\" content=\"https://permify.mintlify.site/_mintlify/api/og/v2?division=Watch+Service\u0026amp;title=Watch+API\u0026amp;theme=9be289e78f6ac24dc5c5d06f\u0026amp;signature=7ca6cc3b7a1b8f392f063f307c9310f06a874ef4485dcc0b3bc2bcde2dd57e92\">\u003cmeta data-mint-head name=\"twitter:image:width\" content=\"1200\">\u003cmeta data-mint-head name=\"twitter:image:height\" content=\"630\">\u003cmeta data-mint-head name=\"msapplication-config\" content=\"/mintlify-assets/_mintlify/favicons/permify/a_feQF0dT9qeMKZe/_generated/favicon/browserconfig.xml\">\u003cmeta data-mint-head name=\"apple-mobile-web-app-title\" content=\"FGA Documentation\">\u003cmeta data-mint-head name=\"msapplication-TileColor\" content=\"#F58320\">\u003clink data-mint-head rel=\"canonical\" href=\"https://proxy-docs.permify.co/api-reference/watch/watch-changes\">\u003clink data-mint-head rel=\"alternate\" type=\"application/xml\" href=\"/sitemap.xml\">\u003clink data-mint-head rel=\"alternate\" type=\"text/markdown\" href=\"/api-reference/watch/watch-changes.md\">\u003cscript data-mint-head type=\"application/ld+json\">{\"@context\":\"https://schema.org\",\"@graph\":[{\"@type\":\"Organization\",\"@id\":\"https://proxy-docs.permify.co/#organization\",\"name\":\"FGA Documentation\",\"url\":\"https://proxy-docs.permify.co\",\"logo\":{\"@type\":\"ImageObject\",\"url\":\"https://mintcdn.com/permify/s--v0P7cOOW3QatA/logo/light.svg?fit=max\u0026auto=format\u0026n=s--v0P7cOOW3QatA\u0026q=85\u0026s=35df6af816b704ec52d1461bb85c5057\"}},{\"@type\":\"WebSite\",\"@id\":\"https://proxy-docs.permify.co#website\",\"name\":\"FGA Documentation\",\"url\":\"https://proxy-docs.permify.co\",\"publisher\":{\"@id\":\"https://proxy-docs.permify.co/#organization\"}},{\"@type\":\"WebPage\",\"@id\":\"https://proxy-docs.permify.co/api-reference/watch/watch-changes#webpage\",\"url\":\"https://proxy-docs.permify.co/api-reference/watch/watch-changes\",\"name\":\"Watch API\",\"dateModified\":\"2026-11-05T14:53:17.791Z\",\"isPartOf\":{\"@id\":\"https://proxy-docs.permify.co#website\"},\"breadcrumb\":{\"@id\":\"https://proxy-docs.permify.co/api-reference/watch/watch-changes#breadcrumb\"}},{\"@type\":\"BreadcrumbList\",\"@id\":\"https://proxy-docs.permify.co/api-reference/watch/watch-changes#breadcrumb\",\"itemListElement\":[{\"@type\":\"ListItem\",\"position\":1,\"name\":\"FGA Documentation\",\"item\":\"https://proxy-docs.permify.co\"},{\"@type\":\"ListItem\",\"position\":2,\"name\":\"Watch API\",\"item\":\"https://proxy-docs.permify.co/api-reference/watch/watch-changes\"}]},{\"@type\":[\"TechArticle\",\"APIReference\"],\"@id\":\"https://proxy-docs.permify.co/api-reference/watch/watch-changes#apireference\",\"headline\":\"Watch API\",\"name\":\"Watch API\",\"url\":\"https://proxy-docs.permify.co/api-reference/watch/watch-changes\",\"mainEntityOfPage\":{\"@id\":\"https://proxy-docs.permify.co/api-reference/watch/watch-changes#webpage\"},\"dateModified\":\"2026-11-05T14:53:17.791Z\",\"publisher\":{\"@id\":\"https://proxy-docs.permify.co/#organization\"},\"isPartOf\":{\"@id\":\"https://proxy-docs.permify.co#website\"}}]}\u003c/script>\u003cscript data-mint-head type=\"application/ld+json\">{\"@context\":\"https://schema.org\",\"@type\":\"WebSite\",\"name\":\"FGA Documentation\",\"creator\":{\"@type\":\"Organization\",\"name\":\"Mintlify\",\"url\":\"https://mintlify.com\"}}\u003c/script>","siteName":"FGA Documentation","nav":{"global":null,"tabs":[{"tab":"FGA Documentation","pages":[{"title":"FGA Documentation","href":"/permify-overview/intro"}]},{"tab":"API References","groups":[{"group":"API Documentation","pages":[{"title":"Introduction","href":"/api-reference/introduction"}]},{"group":"Schema Service","pages":[{"title":"Write Schema","openapi":"post /v1/tenants/{tenant_id}/schemas/write","href":"/api-reference/schema/write-schema"},{"title":"List Schema","openapi":"post /v1/tenants/{tenant_id}/schemas/list","href":"/api-reference/schema/list-schema"},{"title":"Partial Schema Update","openapi":"patch /v1/tenants/{tenant_id}/schemas/partial-write","href":"/api-reference/schema/partial-write"},{"title":"Read Schema","openapi":"post /v1/tenants/{tenant_id}/schemas/read","href":"/api-reference/schema/read-schema"}]},{"group":"Data Service","pages":[{"title":"Write Authorization Data","openapi":"post /v1/tenants/{tenant_id}/data/write","href":"/api-reference/data/write-data"},{"title":"Read Relationships","openapi":"post /v1/tenants/{tenant_id}/data/relationships/read","href":"/api-reference/data/read-relationships"},{"title":"Read Attributes","openapi":"post /v1/tenants/{tenant_id}/data/attributes/read","href":"/api-reference/data/read-attributes"},{"title":"Run Bundle","openapi":"post /v1/tenants/{tenant_id}/data/run-bundle","href":"/api-reference/data/run-bundle"},{"title":"Delete Data","openapi":"post /v1/tenants/{tenant_id}/data/delete","href":"/api-reference/data/delete-data"}]},{"group":"Permission Service","pages":[{"title":"Check Access Control","openapi":"post /v1/tenants/{tenant_id}/permissions/check","href":"/api-reference/permission/check-api"},{"title":"Bulk Check","openapi":"post /v1/tenants/{tenant_id}/permissions/bulk-check","href":"/api-reference/permission/bulk-check"},{"title":"Expand API","openapi":"post /v1/tenants/{tenant_id}/permissions/expand","href":"/api-reference/permission/expand-api"},{"title":"Subject Filtering","openapi":"post /v1/tenants/{tenant_id}/permissions/lookup-subject","href":"/api-reference/permission/lookup-subject"},{"title":"Lookup Entity (Data Filtering)","openapi":"post /v1/tenants/{tenant_id}/permissions/lookup-entity","href":"/api-reference/permission/lookup-entity"},{"title":"Lookup Entity (Streaming)","openapi":"post /v1/tenants/{tenant_id}/permissions/lookup-entity-stream","href":"/api-reference/permission/lookup-entity-stream"},{"title":"Subject Permission List","openapi":"post /v1/tenants/{tenant_id}/permissions/subject-permission","href":"/api-reference/permission/subject-permission"}]},{"group":"Tenancy Service","pages":[{"title":"List Tenants","openapi":"post /v1/tenants/list","href":"/api-reference/tenancy/list-tenants"},{"title":"Create Tenant","openapi":"post /v1/tenants/create","href":"/api-reference/tenancy/create-tenant"},{"title":"Delete Tenant","openapi":"delete /v1/tenants/{id}","href":"/api-reference/tenancy/delete-tenant"}]},{"group":"Bundle Service","pages":[{"title":"Write Bundle","openapi":"post /v1/tenants/{tenant_id}/bundle/write","href":"/api-reference/bundle/write-bundle"},{"title":"Read Bundle","openapi":"post /v1/tenants/{tenant_id}/bundle/read","href":"/api-reference/bundle/read-bundle"},{"title":"Delete Bundle","openapi":"post /v1/tenants/{tenant_id}/bundle/delete","description":null,"href":"/api-reference/bundle/delete-bundle"}]},{"group":"Watch Service","pages":[{"title":"Watch API","openapi":"post /v1/tenants/{tenant_id}/watch","href":"/api-reference/watch/watch-changes"}]}]}]},"basePath":"","title":"Watch API - FGA Documentation","buildId":"dpl_DTau1J5HqS9UTgVSDwGksstFWtPa","deploymentId":"dpl_DTau1J5HqS9UTgVSDwGksstFWtPa","dynamics":["c2aa737661","2b790eda92","b0f84f53ff","a9bb46feb3"],"chunks":["OpenApiReferenceProvider-5FCzAcfS.js","utils-SLtAG4EZ.js","cloneDeep-izs3Hzxb.js","_Uint8Array-BVIqJ90l.js","isObjectLike-C8vmzPEN.js","isArray-Dcu1dQ5t.js","utils-2DZi8ZMu.js","toString-BX-iyh8G.js","isSymbol-CSH9U2Gm.js","addUniqueKeysToSchema-D7J3nkzE.js","snippetPresets-D0Alv0AH.js","style-to-object-BY3JEAdk.js","v4-DIgz8zy6.js","conditional-requirements-CFM0id0Q.js","ApiExamples-BI4qNJ2c.js","isEqual-BfaiBbcl.js","usePlaygroundInputsStore-BD3uyr8j.js","shallow-D8iEBr5z.js","getApiPlaygroundDisplay-CgNP4lzR.js","CodeSnippet-CX-QHuMs.js","CodeSnippets-VlXE-ZUf.js","Page-D9ithiIZ.js","getPastedJson-DYNQkZ1M.js","icon-CzacdwOi.js","MethodPill-2JVqoYKi.js","DuplicateIcon-_xVXs-U8.js","createIcon-BRHrweLo.js","DynamicMarkdown-mQG_iQiE.js","SectionHeading-DMpJzv8f.js","axios-vUo_bRtp.js","Markdown-5FGIym-8.js","clsx-D-TRO5q5.js","lib-DuNMoZ05.js","lib-B8HbPgcC.js","html-void-elements-mCSPHezU.js","dist-CdrJecqK.js","katex-YMM-FMeD.js","marked.esm-CZWythHk.js","AssistantPageLink-CHlcWBLM.js"]}